/***
 * client_echo
 * echo test program
 *
 * Creator : wizard@KLDP.net
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "netfire.h"

int main(int argc, char **argv)
{
  int sockfd;

  /* destination address */
  struct sockaddr_in dest_addr;

  /* Rx and Tx buffer */
  char tx_buff[20];
  char rx_buff[20];

  /* Error detection */
  int dest_addr_size;
  int ret;
  int i;
  struct packet_hdr_t header;

  /* Create client socket */
  sockfd = socket(AF_INET, SOCK_STREAM, 0); 
  if(sockfd < 0)
    {
      printf("socket failed:%d\n", sockfd);
      exit(1);
    }

  memset(&dest_addr, 0, sizeof(dest_addr));
  dest_addr.sin_family = AF_INET;          
  dest_addr.sin_port = htons(7880);
  dest_addr.sin_addr.s_addr = inet_addr("127.0.0.1");
  dest_addr_size = sizeof(dest_addr);

  /* Connect to server */
  ret = connect(sockfd, (struct sockaddr *)&dest_addr, dest_addr_size);
  if(ret < 0)
    {
      printf("connect failed: %d\n", ret);
      exit(1);
    }

  printf("Connected to server...\n");

  /* send echo */
  memset(&header, 0, sizeof(struct packet_hdr_t));
  header.prot = 0x99;
  header.len  = 0x0015;
  header.type = 0x02;
  send(sockfd, &header, sizeof(header), 0);

#if 0
  for(i = 0 ; i < 1000; i++)
    {
      sprintf(tx_buff, "Hello %d", i);
      ret = send(sockfd, tx_buff, sizeof(tx_buff), 0);
      if(ret < 0)
	{
	  printf("send failed:%d\n", ret);
	  exit(1);
	}
      memset(rx_buff, 0, sizeof(rx_buff));
      ret = recv(sockfd, rx_buff, sizeof(rx_buff), 0);
      if(ret < 0)
	{
	  printf("recv failed:%d\n", ret);
	  exit(1);
	};

      printf("%s\n", rx_buff);
    }
#endif

  close(sockfd);
  
  printf("End of Program\n");

  return 0;
}
  
  
