/***
 * netfire
 *
 * netfire v 0.1
 *
 * Creator : wizard@KLDP.net
 ********/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <pthread.h>

#include "netfire.h"

#define UPLOAD_DIR		"/home/zesus/netfire-dev/upload"
#define DOWNLOAD_DIR	"/home/zesus/netfire-dev/download"

int sockfd;

void *RxThread(void *arg)
{
  /* FIX ME */

  return NULL;
}

void *TxThread(void *arg)
{
  int client_sockfd;
  struct request_pkt_t  req;
  /*struct transmit_pkt_t trans; */

  int ret;

  /* copy socket file descriptor */
  client_sockfd = ((struct ThreadArgs *)arg)->sockfd;

  pthread_detach(pthread_self());

  /* recieve a search packet from session server */
  ret = recv(client_sockfd, &req, sizeof(struct request_pkt_t), 0);
  if(ret <= 0)
  {
    printf("TxThread: recv faild:%d\n", ret);
    free(arg);
    return NULL;
  }

  /* check the packet and get offset of file */
  printf("-> [REQ] %.8s %.4ld %s \n", req.userid, req.remain_size, req.filename);

#if 0  /* FIX ME **/
  do
  {
    /* open the file with read-only and sharing option */
    
    /* move the file descriptor to the offset */
    
    /* read data from the file */

    /* make a header and data chunk */
    
    /* begin transmitting data as peer requests */
    
    printf("-> [TRNS] %.8s %.4ld \n", (char *)trans.filename, trans.remain_size);
      
  }while(trans->remain_size);
#endif

  /* close the file - FIX ME*/


  free(arg);

  return NULL;
}

void *SearchThread(void *arg)
{
  int client_sockfd;
  struct search_pkt_t search;
  int ret;

  /* copy socket file descriptor */
  client_sockfd = ((struct ThreadArgs *)arg)->sockfd;

  pthread_detach(pthread_self());

  /* recieve a search packet from session server */
  ret =  recv(client_sockfd, &search, sizeof(struct search_pkt_t), 0);
  if(ret <= 0)
  {
    printf("p2pSvr: recv faild:%d\n", ret);
    free(arg);
    return NULL;
  }
  printf("-> [SRCH] %.8s %.24s\n", search.userid, search.keyword);

  /* search packet is arrived then find it 
     from upload directory  - FIX ME */

  /* Reading upload directory - FIX ME */

  /* matching the pattern - FIX ME */

  /* Sending these files list to the 
     client directly - FIX ME */

  return NULL;

}

void *p2pServer(void *arg)
{
  /* server and client socket descriptor for Peer 2 Peer */
  int serv_sockfd;
  int client_sockfd;

  /* thread arguments and id */
  struct ThreadArgs *thread_args;
  pthread_t hThread;

  /* server and client socket address */
  struct sockaddr_in server_addr;
  struct sockaddr_in client_addr;

  /* client address size */
  int client_addr_size;
  int ret;

  /* buffer of packet */
  struct packet_hdr_t pkt;

  /* create the server socket with TCP option for peer comm */
  serv_sockfd = socket(PF_INET, SOCK_STREAM, 0);
  if(serv_sockfd == -1)
  {
    printf("socket failed:%d\n", serv_sockfd);
    exit(1);
  }

  /* clear and fill out the server address */
  memset(&server_addr, 0, sizeof(server_addr));
  server_addr.sin_family = AF_INET;
  server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  server_addr.sin_port = htons(7881);

  /* bind the server socket to this system */
  if((ret = bind(serv_sockfd,
		 (struct sockaddr *) &server_addr,
		 sizeof(server_addr))) == -1)
  {
    printf("bind faild:%d\n", ret);
    exit(1);
  }

  /* listen the peer client and session server */
  if((ret = listen(serv_sockfd, 20)) == -1)
  {
    printf("listen failed:%d\n", ret);
    exit(1);
  }

  printf("p2pSvr: Ready to serve...\n");

  while(1)
  {
    client_addr_size = sizeof(client_addr);
    client_sockfd = accept(serv_sockfd,
			   (struct sockaddr *) &client_addr,
			   &client_addr_size);
    if(client_sockfd <=0)
    {
      printf("accept failed:%d\n", client_sockfd);
    }

    /* recieve a header of packet from session server or peers */
    ret =  recv(client_sockfd, &pkt, sizeof(struct packet_hdr_t), 0);
    if(ret <= 0)
    {
      printf("p2pSvr: recv faild:%d\n", ret);
      break;
    }
    printf("->[HEADER] %.1x %.1lx %.1x\n", pkt.prot, pkt.len, pkt.type);
    
    thread_args->sockfd = client_sockfd;
    if((thread_args = (struct ThreadArgs *) malloc(sizeof(struct ThreadArgs))) == NULL)
    {
      printf("p2pSvr:  malloc failed\n");
      continue;
    }
   
    switch(pkt.type)
    {
    case SEARCH_TYPE:
      /* this packet is comimg from session server */
      printf("Create a Session Thread...\n");
      pthread_create(&hThread, NULL, SearchThread, thread_args);
      break;
    case REQUEST_TYPE:
    case TRANSMIT_TYPE:
      /* this packet is coming from peer */
      printf("Create a TxThread...\n");
      pthread_create(&hThread, NULL, TxThread, thread_args);
      break;
    default:
      printf("Unknown packet\n");
    }
  }
  return NULL;
}

int sendPktLogin(int sockfd, char *userid, char *passwd)
{
  struct netfire_packet_t packet;
  struct login_pkt_t login;
  struct packet_hdr_t header;
  int ret;

  memset(&packet, 0, sizeof(struct netfire_packet_t));
  memset(&login, 0, sizeof(struct login_pkt_t));
  memset(&header, 0, sizeof(struct packet_hdr_t));

  /* Make a login packet - FIX ME */
  packet.header.prot = PROTOCOL_ID;
  packet.header.type = LOGIN_TYPE;
  packet.header.len  = sizeof(struct login_pkt_t);
  sprintf(packet.chunk.login.userid, "%s", userid);
  sprintf(packet.chunk.login.passwd, "%s", passwd);

  printf("[PACKET] <%.2x %.4x %.2x> %.8s %.8s\n", 
	 packet.header.prot,
	 packet.header.len,
	 packet.header.type,
	 packet.chunk.login.userid,
	 packet.chunk.login.passwd);

  ret = send(sockfd, &packet, sizeof(struct login_pkt_t)+sizeof(struct packet_hdr_t), 0);
  if(ret <= 0)
  {
    printf("send failed:%d\n", ret);
    return -1;
  }

  /* Acknowlegement.. this is for future protocol */
  
  return 0;
}  

int sendPktSearch(int sockfd, char *userid, char *keyword)
{
  /* FIX ME */

  return 0;
}

int sendPktRequest(int sockfd, char *userid, unsigned long remain_size, char *filename)
{
  /* FIX ME */

  return 0;
}

int sendPktTransmit(int sockfd, char *filename, unsigned long remain_size, char *raw, unsigned long size)
{
  /* FIX ME */

  return 0;
}

int begin_netfire(void)
{
  /* destination address */
  struct sockaddr_in dest_addr;

  /* Error detection */
  int dest_addr_size;
  int ret;

  /* thread handle */
  pthread_t p2pthread;

  /* Create p2pServer thread */
  pthread_create(&p2pthread, NULL, p2pServer, NULL);

  /* Create socket file descriptor */
  sockfd = socket(AF_INET, SOCK_STREAM, 0); 
  if(sockfd <= 0)
    {
      printf("socket failed:%d\n", sockfd);
      return -1;
    }

  /* FIX ME */
  memset(&dest_addr, 0, sizeof(dest_addr));
  dest_addr.sin_family = AF_INET;          
  dest_addr.sin_port = htons(7880);
  dest_addr.sin_addr.s_addr = inet_addr("127.0.0.1");
  dest_addr_size = sizeof(dest_addr);

  /* Connect to server */
  ret = connect(sockfd, (struct sockaddr *)&dest_addr, dest_addr_size);
  if(ret < 0)
    {
      printf("connect failed: %d\n", ret);
      return -1;
    }
  return 0;
}

int finish_netfire()
{
  /* kill all thread - FIX ME*/

  close(sockfd);
  return 0;
}

/* test application's main menu */
int displayMainMenu(void)
{
  int item = 0;
  printf("------------------------------------\n");
  printf("      NetFire TEST MAIN MENU        \n");
  printf("------------------------------------\n");
  printf("   1. Send LOGIN packet             \n");
  printf("   2. Send SEARCH packet            \n");
  printf("   3. Send REQUEST packet           \n");
  printf("   4. Send TRANSMIT packet          \n");
  printf("   0. Exit                          \n");
  printf("------------------------------------\n");
  printf("   >> ");
  scanf("%d", &item);
  return item;
}

int main(int argc, char **argv)
{
  int ret;

  char username[8];
  char password[8];

  printf("Starting netfire....\n");

  /* Start netfire */
  if((ret = begin_netfire()) < 0)
  {
    printf("netfire failed:%d\n", ret);
    exit(1);
  }

  /* this is for testing...*/
  do
  {
    ret = displayMainMenu();
    switch(ret)
    {
    case 0:
      printf("Exit now\n");
      break;
    case 1:
      /* send LOGIN packet to session server */
      printf("LOGIN packet\n");
      printf("login id : ");
      scanf("%s", username);
      printf("password : ");
      scanf("%s", password);
      sendPktLogin(sockfd, username, password);
      break;
    case 2:
      /* send SEARCH packet to session server  - FIX ME*/
      printf("SEARCH packet\n");
      break;
    case 3:
      /* send REQUEST packet to peer - FIX ME */
      printf("REQUEST packet\n");
      break;
    case 4:
      /* send TRANSMIT packet to peer - FIX ME */
      printf("TRANSMIT packet\n");
      break;
    default:
      printf("Unknown menu\n");
    }
  }while(ret);


  /* Finish netfire */
  if((ret = finish_netfire()) < 0)
  {
    printf("finish_netfire failed:%d\n", ret);
    exit(1);
  }
  
  printf("End of Program\n");

  return 0;
}
