#ifndef __NETFIRE_H__
#define __NETFIRE_H__

#define PROTOCOL_ID 0xF9

struct ThreadArgs
{
  int sockfd;
};

enum PACKET_TYPE
{
    LOGIN_TYPE = 1,
    SEARCH_TYPE,
    REQUEST_TYPE,
    TRANSMIT_TYPE,
    INVALID_TYPE
} PACKET_TYPE_T;

struct login_pkt_t
{
  char userid[8];
  char passwd[8];
};

struct search_pkt_t
{
  char userid[8];
  char keyword[24];
};

struct request_pkt_t
{
  char userid[8];
  unsigned long remain_size;
  char filename[64];
};

struct transmit_pkt_t
{
  char filename[64];
  unsigned long remain_size;
  unsigned long *raw;
};

typedef struct packet_hdr_t
{
  unsigned char prot;	/* 1 byte  */
  unsigned long len;	/* 4 bytes */
  unsigned char type;	/* 1 bytes */
} PACKET_HDR_T;

typedef struct netfire_packet_t
{
  struct packet_hdr_t header;
  union
  {
    struct login_pkt_t login;
    struct search_pkt_t search;
    /*struct transmit_pkt_t transmit;*/
    struct request_pkt_t request;
  }chunk;
}NETFIRE_PACKET_T;


#endif /* __NETFIRE_H__ */
